from read_chirp_data import *
from func_spike import *
import matplotlib.pyplot as plt
import numpy as np
from IPython import embed #Funktionen importieren




data_dir = "../data"
data_chirps = ("2018-11-09-ad-invivo-1", "2018-11-09-ae-invivo-1", "2018-11-09-ag-invivo-1", "2018-11-13-aa-invivo-1", "2018-11-13-ac-invivo-1", "2018-11-13-ad-invivo-1", "2018-11-13-ah-invivo-1", "2018-11-13-ai-invivo-1", "2018-11-13-aj-invivo-1", "2018-11-13-ak-invivo-1", "2018-11-13-al-invivo-1", "2018-11-14-aa-invivo-1", "2018-11-14-ac-invivo-1", "2018-11-14-ad-invivo-1", "2018-11-14-af-invivo-1", "2018-11-14-ag-invivo-1", "2018-11-14-ah-invivo-1", "2018-11-14-ai-invivo-1", "2018-11-14-ak-invivo-1", "2018-11-14-al-invivo-1", "2018-11-14-am-invivo-1", "2018-11-14-an-invivo-1", "2018-11-20-aa-invivo-1", "2018-11-20-ab-invivo-1", "2018-11-20-ac-invivo-1", "2018-11-20-ad-invivo-1", "2018-11-20-ae-invivo-1", "2018-11-20-af-invivo-1", "2018-11-20-ag-invivo-1", "2018-11-20-ah-invivo-1", "2018-11-20-ai-invivo-1") 



inch_factor = 2.54
data_rate_dict = {}
for dataset in data_chirps:
	
	data_rate_dict[dataset] = []
	chirp_spikes = read_chirp_spikes(os.path.join(data_dir, dataset))
	times = read_chirp_times(os.path.join(data_dir, dataset))
	eod = read_chirp_eod(os.path.join(data_dir, dataset))
	df_map = map_keys(chirp_spikes)


	for i in df_map.keys():
		freq = list(df_map[i])
		k = freq[0]
		phase = list(chirp_spikes[k].keys())[0]

		spikes = chirp_spikes[k][phase]
		rate = len(spikes)/ 1.2
		data_rate_dict[dataset].append(rate)		

fig, ax = plt.subplots(figsize=(20/inch_factor, 10/inch_factor))
for dataset in data_rate_dict:
	plt.plot(data_rate_dict[dataset])

plt.title('Test for sequence effects', fontsize = 24)
plt.xlabel('Number of stimulus presentations', fontsize = 22)
plt.ylabel('Firing rates of cells', fontsize = 22)
plt.tick_params(axis='both', which='major', labelsize = 22)
ax.spines['right'].set_visible(False)
ax.spines['top'].set_visible(False)
fig.tight_layout()
plt.show()


